Subject: bug#25641: 25.1; insert-char function inconsistency

From: Pablo Mercader Alcántara <[email-masked]>
Date: Tue, 7 Feb 2017 20:45:43 -0400

Ok, I understand both arguments. I think it's a trivial problem too.

I had the problem because the first time I typed exactly what the help
buffer told me. But later I saw that there were different "BELL"
characters with different terminations. The problem is that the
information in the help screen should say C-x 8 RET BELL (BEL) for one
character and C-x 8 RET BELL for the other.

I know its a really small thing. Any way thanks for the fast answer!

2017-02-07 13:04 GMT-04:00 Stephen Berman <[email-masked]>:
> On Tue, 07 Feb 2017 18:08:48 +0200 Eli Zaretskii <[email-masked]> wrote:
>
>>> From: Pablo Mercader Alcántara <[email-masked]>
>>> Date: Tue, 7 Feb 2017 09:04:01 -0400
>>>
>>> Character code properties: customize what to show
>>>   old-name: BELL
>>>   general-category: Cc (Other, Control)
>>> [...]
>>> Character code properties: customize what to show
>>>   name: BELL
>>>   general-category: So (Symbol, Other)
>>>   decomposition: (128276) ('🔔')
>>>
>>> Its a different character but it also states that I could write it using
>>> C-x 8 RET BELL. To me that is an inconsistency, because one of the
>>> commands that the help screen showed me was C-x 8 RET BELL and that
>>> clearly doesn't work.
>>
>> It's not an inconsistency: the first one has BELL as its "old name"
>> property (and has no "name" property), the second one as its "name"
>> property.  This is per Unicode definitions in their character
>> database, which Emacs uses for this feature.  Unicode removed the
>> names of low control characters in some version of their standard,
>> leaving the "old name" behind for compatibility.
>>
>> Emacs displays "old name" if "name" is missing.
>>
>> If you type "C-x 8 RET BELL" and hit TAB right after that, Emacs will
>> tell you this is "complete, but not unique".  Another TAB will pop up
>> the list of completion candidates, where you will see both BELLs (and
>> a couple more characters).
>>
>> I don't think there's a bug here.
>
> But as the OP noted, the *Help* buffer for the character #x7 says:
>
>              to input: type "C-x 8 RET 7" or "C-x 8 RET BELL"
>
> yet hitting RET after `C-x RET BELL' only inserts the character #x1f514;
> the only way to insert it via `C-x 8' is to hit TAB and then click on
> the entry `BELL (BEL)' in the *Completions* buffer.  So the *Help* is at
> best misleading.
>
> Steve Berman